function mask = mask_funk(N) 

% creates a mask for a square grid with N points

% a simpler version using diag should be possible

L = sqrt(N);
  
mask=zeros(N,N);
  
%center elements
for j=1:L-2
  for i=2:L-1
    n = i+L*j;
    mask(n,n-L) = 1;  mask(n,n-1) = 1;  mask(n,n+1) = 1;  mask(n,n+L) = 1;
  end
end

%corner element 1 and L;
i=1;
mask(i,i+1)=1; mask(i,i+L)=1;
i=L;
mask(i,i-1)=1; mask(i,i+L)=1;

% corner elements N-L+1 and N
i= N-L+1;
mask(i,i-L)=1; mask(i,i+1)=1;
i= N;
mask(i,i-L)=1; mask(i,i-1)=1;

%edge elements
for i=2:L-1
  mask(i,i-1)=1; mask(i,i+1)=1; mask(i,i+L)=1;
end
for i=L+1:L:N-2*L+1
  mask(i,i-L)=1; mask(i,i+1)=1; mask(i,i+L)=1;
end
for i=2*L:L:N-L
  mask(i,i-L)=1; mask(i,i-1)=1; mask(i,i+L)=1;
end
for i=N-L+2:N-1
  mask(i,i-L)=1; mask(i,i-1)=1; mask(i,i+1)=1;
end
